{% macro input(name, conf, coll_settings) -%}
    {% if conf.type=="str" %}
        {{ str_input(name, conf, coll_settings) }}
    {% elif conf.type=="int" %}
        {{ int_input(name, conf, coll_settings) }}
    {% elif conf.type=="float" %}
        {{ float_input(name, conf, coll_settings) }}
    {% elif conf.type=="bool" %}
        {{ bool_input(name, conf, coll_settings) }}
    {% else %}
        {{ str_input(name, conf, coll_settings) }}
    {% endif %}
{%- endmacro %}

{%- macro str_input(name, conf, coll_settings) -%}
    {% if conf.choices %}
        <select {% if not conf.read_only %} name="{{ name }}" id="{{ name }}" {% endif %}>
            {% for choice in conf.choices %}
                {% if coll_settings[name] == choice %}
                    <option selected>{{choice}}</option>
                {%else%}
                    <option>{{choice}}</option>
                {%endif%}
            {% endfor %}
        </select>
    {% else %}
        <input {% if not conf.read_only %} name="{{ name }}" id="{{ name }}" {% endif %}
               type="text"
               {% if coll_settings[name] %}
                   value="{{ coll_settings[name] }}"
               {% elif conf.default %}
                   value="{{ conf.default }}"
               {% endif %}
               {% if conf.required %} required {% endif %}
               {% if conf.read_only %} readonly {% endif %}
        >
    {% endif %}
{%- endmacro  %}

{%- macro int_input(name, conf, coll_settings) -%}
    <input {% if not conf.read_only %} name="{{ name }}" id="{{ name }}" {% endif %}
           type="number"
           {% if coll_settings[name] %}
               value="{{ coll_settings[name] }}"
           {% elif conf.default %}
               value="{{ conf.default }}"
           {% else %}
               value="0"
           {% endif %}
           {% if conf.required %} required {% endif %}
           {% if conf.read_only %} readonly {% endif %}
    >
{%- endmacro  %}

{%- macro float_input(name, conf, coll_settings) -%}
    <input {% if not conf.read_only %} name="{{ name }}" id="{{ name }}" {% endif %}
           type="number"
           step="0.001"
           {% if coll_settings[name] %}
               value="{{ coll_settings[name] }}"
           {% elif conf.default %}
               value="{{ conf.default }}"
           {% else %}
               value="0.0"
           {% endif %}
           {% if conf.required %} required {% endif %}
           {% if conf.read_only %} readonly {% endif %}
    >
{%- endmacro  %}

{%- macro bool_input(name, conf, coll_settings) -%}
    <input type="checkbox"
           {% if not conf.read_only %} name="{{ name }}" id="{{ name }}" {% endif %}
           {% if (coll_settings[name] is none and conf.default) or coll_settings[name]  %}checked{% endif %}
           {% if conf.read_only %} readonly {% endif %}
    >
{%- endmacro  %}


{%- macro label_with_tooltip(key, conf) -%}
    <label {% if not conf.read_only %} for={{key}} {% endif %} {% if conf.required %}class="required tooltip"{% else %}class="tooltip"{% endif %}>
        {{conf.label}}
        {% if conf.description %}
            <span class="tooltiptext-label">{{conf.description}}</span>
        {% endif %}
    </label>
{%- endmacro %}

{%- macro label_and_tooltip(key, conf) -%}
    <label {% if not conf.read_only %} for={{key}} {% endif %} {% if conf.required %}class="required"{% endif %}>{{conf.label}}</label>
    {% if conf.description %}
        <span class="tooltiptext">{{conf.description}}</span>
    {% endif %}
{%- endmacro %}